# Copyright (c) 2000-2012, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

%define section free
%define oname apacheds-daemon

Summary:        Reusable Daemon Framework
Name:           apacheds-daemon
Version:        1.1.5
Release:        3%{?dist}
Epoch:          0
Group:          Applications/Internet
License:        Apache 2.0 License
URL:            http://directory.apache.org/
Source0:        %{name}-%{version}.tar.gz
# svn export http://svn.apache.org/repos/asf/directory/daemon/tags/1.1.5/ apacheds-daemon-1.1.5

Source1:        directory-pom-1.0.4.xml
Source2:        %{name}-jpp-depmap.xml
Source3:        %{name}-settings.xml
Source4:        directory-project-12.tar.gz
Source5:        apache-jar-resource-bundle-1.3.jar
Patch0:         directory-project-12-pom.patch

BuildRequires:  jpackage-utils >= 0:1.7.5
BuildRequires:  java-devel >= 0:1.6.0
BuildRequires:  ant >= 0:1.7.1
BuildRequires:  maven2 => 0:2.0.8
BuildRequires:  maven2-plugin-compiler
BuildRequires:  maven2-plugin-install
BuildRequires:  maven2-plugin-jar
BuildRequires:  maven2-plugin-javadoc
BuildRequires:  maven2-plugin-plugin
BuildRequires:  maven2-plugin-remote-resources
BuildRequires:  maven2-plugin-resources
BuildRequires:  maven2-plugin-stage
BuildRequires:  maven-release
BuildRequires:  maven-surefire-plugin
BuildRequires:  maven-surefire-provider-junit4
BuildRequires:  rat-maven-plugin
BuildRequires:  apacheds-base
BuildRequires:  geronimo-genesis
BuildRequires:  izpack
BuildRequires:  apache-commons-daemon
BuildRequires:  plexus-utils
BuildRequires:  slf4j
BuildRequires:  tanukiwrapper

Requires(post):   jpackage-utils >= 0:1.7.5
Requires(postun): jpackage-utils >= 0:1.7.5

BuildArch:      noarch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root

%description
Reusable framework for daemon applications based on Commons
Daemon Jsvc and Procrun. A small installation layout pattern
combined with some utility classes allows applications to 
become UNIX daemons or Windows NT services.  Reusable
bootstrappers along with an installer plugin allow for the
rapid creation of standalone daemon applications.

%package bootstrappers
Group:          Applications/Internet
Summary:        Apache DS Daemon bootstrappers
Requires:       slf4j
Obsoletes:      apacheds-daemon-bootstrappers < %{epoch}:%{version}-%{release}
Provides:       apacheds-daemon-bootstrappers = %{epoch}:%{version}-%{release}
Requires:  java >= 0:1.6.0
Requires:  apache-commons-daemon
Requires:  slf4j
Requires:  tanukiwrapper

%description bootstrappers
Daemon bootstrappers which initialize a classloader with 
jars laid out in an installation footprint.

%package maven2-plugin
Group:          Development/Libraries
Summary:        Build installers
Requires:       %{name}-bootstrappers = %{epoch}:%{version}-%{release}
Requires:       java >= 0:1.6.0
Requires:       maven2 >= 0:2.0.8
Requires:       izpack
Requires:       plexus-utils
Obsoletes:      apacheds-daemon-maven2-plugin < %{epoch}:%{version}-%{release}
Provides:       apacheds-daemon-maven2-plugin = %{epoch}:%{version}-%{release}

%description maven2-plugin
A plugin that builds installers using bootstrappers
and commons-daemon procrun and jsvc.

%package javadoc
Group:          Development/Documentation
Summary:        Javadoc for %{name}
Obsoletes:      apacheds-daemon-javadoc < %{epoch}:%{version}-%{release}
Provides:       apacheds-daemon-javadoc = %{epoch}:%{version}-%{release}

%description javadoc
%{summary}.

%prep
%setup -q -n %{oname}-%{version}
gzip -dc %{SOURCE4} | tar xf -
%patch0

%build
cp %{SOURCE3} maven2-settings.xml

sed -i -e "s|<url>__JPP_URL_PLACEHOLDER__</url>|<url>file://`pwd`/m2_repo/repository</url>|g" maven2-settings.xml
sed -i -e "s|<url>__JAVADIR_PLACEHOLDER__</url>|<url>file://`pwd`/external_repo</url>|g" maven2-settings.xml
sed -i -e "s|<url>__MAVENREPO_DIR_PLACEHOLDER__</url>|<url>file://`pwd`/m2_repo/repository</url>|g" maven2-settings.xml
sed -i -e "s|<url>__MAVENDIR_PLUGIN_PLACEHOLDER__</url>|<url>file:///usr/share/maven2/plugins</url>|g" maven2-settings.xml
sed -i -e "s|<url>__ECLIPSEDIR_PLUGIN_PLACEHOLDER__</url>|<url>file:///usr/share/eclipse/plugins</url>|g" maven2-settings.xml

export M2SETTINGS=$(pwd)/maven2-settings.xml
export MAVEN_REPO_LOCAL=`pwd`/m2_repo/repository

mkdir -p $MAVEN_REPO_LOCAL/JPP/maven2/default_poms/
cp %{SOURCE1} $MAVEN_REPO_LOCAL/JPP/maven2/default_poms/org.apache.directory-build.pom
cp directory-project-12/pom.xml \
   $MAVEN_REPO_LOCAL/JPP/maven2/default_poms/org.apache.directory.project-project.pom
cp pom.xml m2_repo/repository/JPP/maven2/default_poms/JPP-apacheds-daemon-build.pom

mkdir -p $MAVEN_REPO_LOCAL/org.apache/
cp %{SOURCE5} $MAVEN_REPO_LOCAL/org.apache/apache-jar-resource-bundle.jar

mkdir external_repo
ln -s %{_javadir} external_repo/JPP

pushd bootstrappers
mvn-jpp -e \
        -s ${M2SETTINGS} \
        -Dmaven.repo.local=$MAVEN_REPO_LOCAL \
        -Dmaven2.jpp.depmap.file=%{SOURCE2} \
        install javadoc:javadoc
popd
pushd plugin
mvn-jpp -e \
        -s ${M2SETTINGS} \
        -Dmaven.repo.local=$MAVEN_REPO_LOCAL \
        -Dmaven2.jpp.depmap.file=%{SOURCE2} \
        install javadoc:javadoc
popd

%install
rm -rf $RPM_BUILD_ROOT

# jars
install -d -m 0755 $RPM_BUILD_ROOT%{_javadir}
install -m 644 bootstrappers/target/daemon-bootstrappers-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}-bootstrappers-%{version}.jar
install -m 644 plugin/target/daemon-plugin-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}-maven2-plugin-%{version}.jar
(cd $RPM_BUILD_ROOT%{_javadir} && for jar in *-%{version}*; do ln -sf ${jar} `echo $jar| sed  "s|-%{version}||g"`; done)

# poms
install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/maven2/poms
install -m 644 %{SOURCE1} \
        $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP-apacheds-build.pom
%add_to_maven_depmap org.apache.directory build %{version} JPP apacheds-build
install -m 644 pom.xml \
        $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP-%{name}-parent.pom
%add_to_maven_depmap org.apache.directory.daemon daemon-parent %{version} JPP %{name}-parent
install -m 644 bootstrappers/pom.xml \
        $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP-%{name}-bootstrappers.pom
%add_to_maven_depmap org.apache.directory.daemon daemon-bootstrappers %{version} JPP %{name}-bootstrappers
install -m 644 plugin/pom.xml \
        $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP-%{name}-maven2-plugin.pom
%add_to_maven_depmap org.apache.directory.daemon daemon-plugin %{version} JPP %{name}-maven2-plugin

install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/maven2/plugins
pushd $RPM_BUILD_ROOT%{_datadir}/maven2/plugins
    ln -sf %{_javadir}/%{name}-maven2-plugin.jar
popd

# javadoc
install -d -m 0755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/bootstrappers
#install -d -m 0755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/plugin
cp -pr bootstrappers/target/site/apidocs/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/bootstrappers
#cp -pr plugin/target/site/apidocs/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/plugin
ln -sf %{name}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name} #ghost

%clean
rm -rf $RPM_BUILD_ROOT

%post bootstrappers
%update_maven_depmap

%postun bootstrappers
%update_maven_depmap

%files bootstrappers
%defattr(0644,root,root,0755)
%doc directory-project-12/LICENSE.txt
%{_javadir}/%{name}-bootstrappers*.jar
%{_datadir}/maven2/poms/*
%{_mavendepmapfragdir}/*

%files maven2-plugin
%defattr(0644,root,root,0755)
%doc directory-project-12/LICENSE.txt
%{_javadir}/%{name}-maven2-plugin*.jar
%{_datadir}/maven2/poms/JPP-%{name}-maven2-plugin.pom
%{_datadir}/maven2/plugins/*.jar

%files javadoc
%defattr(0644,root,root,0755)
%{_javadocdir}/%{name}-%{version}
%{_javadocdir}/%{name}

%changelog
* Mon Jul 30 2012 Ralph Apel <r.apel at r-apel.de> 0:1.1.5-3
- Rebuild for JPP-6

* Fri Apr 17 2009 Ralph Apel <r.apel at r-apel.de> 0:1.1.5-2.jpp5
- Add daemon-parent pom

* Wed Apr 15 2009 Ralph Apel <r.apel at r-apel.de> 0:1.1.5-1.jpp5
- 1.1.5

* Tue Jul 08 2008 Ralph Apel <r.apel at r-apel.de> 0:1.0.2-2.jpp5
- Import to cvs

* Fri Jun 20 2008 Ralph Apel <r.apel at r-apel.de> 0:1.0.2-1.jpp5
- 1.0.2 as apache-daemon10

* Thu Mar 15 2007 Ralph Apel <r.apel at r-apel.de> 0:1.0.0-2jpp
- Provide initial pom in local repo
- Add nlog4j (B)R
- Add Requires for jakarta-commons-daemon, plexus-utils, slf4j, nlog4j

* Fri Oct 27 2006 Ralph Apel <r.apel at r-apel.de> 0:1.0.0-1jpp
- First release for apacheds-1.0.0
- Add post/postun Requires for javadoc
- Add gcj_support option
- FIXME: native integration pending

